
/*  A Bison parser, made from ccc.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	TR_DEFINE	257
#define	TR_END	258
#define	TR_SETCHAR	259
#define	TR_SETCHARBB	260
#define	TR_HMOVE	261
#define	TR_VMOVE	262
#define	T_REAL	263
#define	TR_PT	264
#define	TR_XHEIGHT	265
#define	TR_CAPHEIGHT	266
#define	TR_FONTDEPTH	267
#define	TR_DESIGNSIZE	268
#define	TR_EM	269
#define	TR_HEIGHT	270
#define	TR_WIDTH	271
#define	TR_DEPTH	272
#define	TR_BBHEIGHT	273
#define	TR_BBWIDTH	274
#define	T_CHARNAME	275

#line 1 "ccc.y"

/* ccc.y -- Bison and C code to parse a CCC file.

Copyright (C) 1992 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include "config.h"

#include <ctype.h>
#include "encoding.h"
#include "filename.h"
#include "varstring.h"

#include "char.h"
#include "input-ccc.h"
#include "main.h"


/* Set the return value RET to either the dimension DIM, if NAME is a
   valid character name, or an invalid sentinel.  Used in the
   `unit_of_measure' rule.  */
#define DO_CHAR_DIMEN(ret, dimen, name)					\
  if (char_known_p (name))						\
    ret = dimen_init (dimen);						\
  else									\
    DIMEN_VALID (ret) = false


static ccc_cmd_list_type *append_cmd (ccc_cmd_list_type *, ccc_cmd_type);
static ccc_cmd_list_type *init_cmd_list (ccc_cmd_type);
static boolean char_known_p (charname_type);
static dimen_type dimen_init (real);
static int token_number (string);
static void yyerror (string);
static int yylex ();

#line 51 "ccc.y"
typedef union
{
  int int_val;
  real real_val;
  dimen_type dimen_val;
  charname_type charname_val;
  ccc_cmd_type cmd_val;
  ccc_cmd_list_type *cmd_list_val;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		50
#define	YYFLAG		-32768
#define	YYNTBASE	25

#define YYTRANSLATE(x) ((unsigned)(x) <= 275 ? yytranslate[x] : 33)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    23,
    24,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    22,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,    10,    12,    15,    20,    23,    25,    27,
    29,    31,    33,    36,    38,    40,    42,    44,    46,    48,
    53,    58,    63,    68
};

static const short yyrhs[] = {    -1,
    25,    26,     0,     3,    21,    22,    27,     4,     0,    28,
     0,    27,    28,     0,    29,    23,    21,    24,     0,    30,
    31,     0,     5,     0,     6,     0,     7,     0,     8,     0,
    32,     0,     9,    32,     0,    10,     0,    12,     0,    14,
     0,    15,     0,    13,     0,    11,     0,    16,    23,    21,
    24,     0,    17,    23,    21,    24,     0,    18,    23,    21,
    24,     0,    19,    23,    21,    24,     0,    20,    23,    21,
    24,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    72,    73,    76,    84,    86,    90,    99,   110,   110,   112,
   112,   114,   116,   124,   129,   130,   131,   132,   133,   134,
   138,   142,   146,   151
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","TR_DEFINE",
"TR_END","TR_SETCHAR","TR_SETCHARBB","TR_HMOVE","TR_VMOVE","T_REAL","TR_PT",
"TR_XHEIGHT","TR_CAPHEIGHT","TR_FONTDEPTH","TR_DESIGNSIZE","TR_EM","TR_HEIGHT",
"TR_WIDTH","TR_DEPTH","TR_BBHEIGHT","TR_BBWIDTH","T_CHARNAME","'='","'('","')'",
"chardefs","chardef","statements","statement","set_cmd","move_cmd","dimension",
"unit_of_measure", NULL
};
#endif

static const short yyr1[] = {     0,
    25,    25,    26,    27,    27,    28,    28,    29,    29,    30,
    30,    31,    31,    32,    32,    32,    32,    32,    32,    32,
    32,    32,    32,    32
};

static const short yyr2[] = {     0,
     0,     2,     5,     1,     2,     4,     2,     1,     1,     1,
     1,     1,     2,     1,     1,     1,     1,     1,     1,     4,
     4,     4,     4,     4
};

static const short yydefact[] = {     1,
     0,     0,     2,     0,     0,     8,     9,    10,    11,     0,
     4,     0,     0,     3,     5,     0,     0,    14,    19,    15,
    18,    16,    17,     0,     0,     0,     0,     0,     7,    12,
     0,    13,     0,     0,     0,     0,     0,     6,     0,     0,
     0,     0,     0,    20,    21,    22,    23,    24,     0,     0
};

static const short yydefgoto[] = {     1,
     3,    10,    11,    12,    13,    29,    30
};

static const short yypact[] = {-32768,
    32,    12,-32768,    14,    23,-32768,-32768,-32768,-32768,    19,
-32768,    11,    -9,-32768,-32768,    16,     2,-32768,-32768,-32768,
-32768,-32768,-32768,    15,    17,    18,    20,    21,-32768,-32768,
    22,-32768,    24,    26,    27,    28,    29,-32768,    30,    31,
    33,    34,    35,-32768,-32768,-32768,-32768,-32768,    39,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,    41,-32768,-32768,-32768,    25
};


#define	YYLAST		59


static const short yytable[] = {    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    14,     6,     7,     8,     9,     6,     7,     8,
     9,    49,     4,    16,     2,     5,    31,    33,    50,    34,
    35,    32,    36,    37,    39,    38,    40,    41,    42,    43,
    15,     0,     0,    44,    45,     0,    46,    47,    48
};

static const short yycheck[] = {     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    10,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,     4,     5,     6,     7,     8,     5,     6,     7,
     8,     0,    21,    23,     3,    22,    21,    23,     0,    23,
    23,    17,    23,    23,    21,    24,    21,    21,    21,    21,
    10,    -1,    -1,    24,    24,    -1,    24,    24,    24
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/gnu/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/gnu/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 77 "ccc.y"
{ 
                    /* It doesn't hurt to define a character that won't
                       be used, so we don't call `char_known_p' here.  */
                    ccc_chars[yyvsp[-3].charname_val.code] = yyvsp[-1].cmd_list_val;
                  ;
    break;}
case 4:
#line 85 "ccc.y"
{ yyval.cmd_list_val = init_cmd_list (yyvsp[0].cmd_val); ;
    break;}
case 5:
#line 87 "ccc.y"
{ yyval.cmd_list_val = append_cmd (yyvsp[-1].cmd_list_val, yyvsp[0].cmd_val); ;
    break;}
case 6:
#line 91 "ccc.y"
{
                      CCC_VALID (yyval.cmd_val) = char_known_p (yyvsp[-1].charname_val);
                      if (CCC_VALID (yyval.cmd_val))
                        {
                          CCC_OPCODE (yyval.cmd_val) = yyvsp[-3].int_val;
  	  	          CCC_CHARCODE (yyval.cmd_val) = yyvsp[-1].charname_val.code;
                        }
                    ;
    break;}
case 7:
#line 100 "ccc.y"
{
                      CCC_VALID (yyval.cmd_val) = DIMEN_VALID (yyvsp[0].dimen_val);
                      if (CCC_VALID (yyval.cmd_val))
                        {
                          CCC_OPCODE (yyval.cmd_val) = yyvsp[-1].int_val;
  		          CCC_DIMEN (yyval.cmd_val) = yyvsp[0].dimen_val;
                        }
                    ;
    break;}
case 12:
#line 115 "ccc.y"
{ yyval.dimen_val = yyvsp[0].dimen_val; ;
    break;}
case 13:
#line 117 "ccc.y"
{
                      DIMEN_AMOUNT (yyval.dimen_val) = yyvsp[-1].real_val * DIMEN_AMOUNT (yyvsp[0].dimen_val);
		      DIMEN_ABSOLUTE (yyval.dimen_val) = DIMEN_ABSOLUTE (yyvsp[0].dimen_val);
                      DIMEN_VALID (yyval.dimen_val) = DIMEN_VALID (yyvsp[0].dimen_val);
		    ;
    break;}
case 14:
#line 125 "ccc.y"
{
                      yyval.dimen_val = dimen_init (1);
                      DIMEN_ABSOLUTE (yyval.dimen_val) = true;
                    ;
    break;}
case 15:
#line 129 "ccc.y"
{ yyval.dimen_val = dimen_init (ccc_fontinfo.cap_height); ;
    break;}
case 16:
#line 130 "ccc.y"
{ yyval.dimen_val = dimen_init (ccc_fontinfo.design_size); ;
    break;}
case 17:
#line 131 "ccc.y"
{ yyval.dimen_val = dimen_init (ccc_fontinfo.em); ;
    break;}
case 18:
#line 132 "ccc.y"
{ yyval.dimen_val = dimen_init (ccc_fontinfo.font_depth); ;
    break;}
case 19:
#line 133 "ccc.y"
{ yyval.dimen_val = dimen_init (ccc_fontinfo.xheight); ;
    break;}
case 20:
#line 135 "ccc.y"
{
                      DO_CHAR_DIMEN (yyval.dimen_val, CHAR_HEIGHT (*chars[yyvsp[-1].charname_val.code]), yyvsp[-1].charname_val);
                    ;
    break;}
case 21:
#line 139 "ccc.y"
{
                      DO_CHAR_DIMEN (yyval.dimen_val, CHAR_SET_WIDTH (*chars[yyvsp[-1].charname_val.code]), yyvsp[-1].charname_val);
                    ;
    break;}
case 22:
#line 143 "ccc.y"
{
                      DO_CHAR_DIMEN (yyval.dimen_val, CHAR_DEPTH (*chars[yyvsp[-1].charname_val.code]), yyvsp[-1].charname_val);
                    ;
    break;}
case 23:
#line 147 "ccc.y"
{
                      DO_CHAR_DIMEN
                        (yyval.dimen_val, BB_HEIGHT (CHAR_BB (*chars[yyvsp[-1].charname_val.code])), yyvsp[-1].charname_val);
                    ;
    break;}
case 24:
#line 152 "ccc.y"
{
                      DO_CHAR_DIMEN
                        (yyval.dimen_val, BB_WIDTH (CHAR_BB (*chars[yyvsp[-1].charname_val.code])), yyvsp[-1].charname_val);
                    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/gnu/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 157 "ccc.y"


/* Let's hope Bison will never use this value as a token code.  */
#define NOT_A_TOKEN (-1)

/* Keep track of line numbers for error messages.  */
static unsigned lineno = 1;

static int get_word_token (FILE *);


/* We don't want to use the libfile routines for CCC files, since
   there's no reason for them to be in the system data directories.  So
   we must have our own error routines.  */
#define CCC_WARN1(fmt, e1) \
  fprintf (stderr, "%s:%u: " fmt ".\n", ccc_filename, lineno, e1)
#define CCC_WARN2(fmt, e1, e2) \
  fprintf (stderr, "%s:%u: " fmt ".\n", ccc_filename, lineno, e1, e2)

static void
yyerror (string s)
{
  fprintf (stderr, "%s:%u: %s\n", ccc_filename, lineno, s);
}

/* Return the next token in `ccc_file'.  */

static int
yylex (void)
{
  int t = NOT_A_TOKEN;

  do
    {
      int c = getc (ccc_file);

      /* Skip whitespace.  */
      while (c != EOF && isspace (c))
        {
          if (c == '\n') lineno++;
          c = getc (ccc_file);
	}
        
      switch (c)
        {
        case EOF:
          t = 0;
          lineno = 1; /* For the next file (if we ever allow one).  */
          break;

        /* Comments begin with % and go to the end of the line.  */
        case '%':
          while ((c = getc (ccc_file)) != '\n' && c != EOF)
            ;
          if (c == '\n') lineno++;
          break;

        case '0': case '1': case '2': case '3': case '4':
	case '5': case '6': case '7': case '8': case '9':
	case '.': case '-': case '+':
          ungetc (c, ccc_file);
          fscanf (ccc_file, "%lf", &yylval.real_val);
          t = T_REAL;
          break;

        default:
          if (isalpha (c))
            {
              ungetc (c, ccc_file);
              t = get_word_token (ccc_file);
            }
          else
            t = c;
          break;
        }
    }
  while (t == NOT_A_TOKEN);

  return t;
}

/* Return either the Bison-defined value for the token equal to the
   next nonalpha-delimited word in F, or if the word is
   the encoding name of a character, return T_CHARNAME.

   Sets the global `yylval.charname_val' to the encoding number of a
   character encoding name, if the word is an encoding name.

   Assumes the first character is valid (i.e., alpha).  */

static int
get_word_token (FILE *f)
{
  int token_value, encoding_value;
  int c;
  variable_string word = vs_init ();

  while ((c = getc (f)) != EOF && isalpha (c))
    vs_append_char (&word, c);

  if (c != EOF)
    ungetc (c, f);

  /* Add the terminating null.  */
  vs_append_char (&word, 0);

  token_value = token_number (VS_CHARS (word));
  encoding_value = encoding_number (encoding_info, VS_CHARS (word));

  /* If the identifier is neither a reserved word nor a known character
     name, return T_CHARNAME and call it character zero.  */
  if (token_value == NOT_A_TOKEN && encoding_value == -1)
    {
      CCC_WARN1 ("Unknown identifier `%s'", VS_CHARS (word));
      encoding_value = 0;
    }

  if (token_value != NOT_A_TOKEN && encoding_value != -1)
    CCC_WARN1 ("`%s' both a reserved word and a character name",
 	      VS_CHARS (word));

  if (token_value == NOT_A_TOKEN)
    {
      yylval.charname_val.code = encoding_value;
      yylval.charname_val.name = VS_CHARS (word);
      token_value = T_CHARNAME;
    }
  else
    {
      yylval.int_val = token_value;
      vs_free (&word);
    }
  
  return token_value;
}


/* If WORD is a reserved word, return the corresponding token code;
   otherwise, return `NOT_A_TOKEN'.  */

static int
token_number (string word)
{
  if (STREQ (word, "define"))		return TR_DEFINE;
  else if (STREQ (word, "bbheight"))	return TR_BBWIDTH;
  else if (STREQ (word, "bbwidth"))	return TR_BBWIDTH;
  else if (STREQ (word, "capheight"))	return TR_CAPHEIGHT;
  else if (STREQ (word, "depth"))	return TR_DEPTH;
  else if (STREQ (word, "designsize"))	return TR_DESIGNSIZE;
  else if (STREQ (word, "em"))		return TR_EM;
  else if (STREQ (word, "end"))		return TR_END;
  else if (STREQ (word, "fontdepth"))	return TR_FONTDEPTH;
  else if (STREQ (word, "height"))	return TR_HEIGHT;
  else if (STREQ (word, "hmove"))	return TR_HMOVE;
  else if (STREQ (word, "pt"))		return TR_PT;
  else if (STREQ (word, "setchar"))	return TR_SETCHAR;
  else if (STREQ (word, "setcharbb"))	return TR_SETCHARBB;
  else if (STREQ (word, "vmove"))	return TR_VMOVE;
  else if (STREQ (word, "width"))	return TR_WIDTH;
  else if (STREQ (word, "xheight"))	return TR_XHEIGHT;
  else
    return NOT_A_TOKEN;
}

/* Return a new list of CCC commands, initialized to contain CMD.  If
   CMD is invalid, return NULL.  */

static ccc_cmd_list_type *
init_cmd_list (ccc_cmd_type cmd)
{
  ccc_cmd_list_type *l;
  
  if (CCC_VALID (cmd))
    {
      l = XTALLOC1 (ccc_cmd_list_type);
      *l = list_init ();
      l = append_cmd (l, cmd);
    }
  else
    l = NULL;

  return l;
}


/* Add CMD to CMD_LIST and return CMD_LIST.  If CMD is invalid, don't
   add it.  If CMD_LIST is NULL, initialize it.  */

static ccc_cmd_list_type *
append_cmd (ccc_cmd_list_type *cmd_list, ccc_cmd_type cmd)
{
  if (CCC_VALID (cmd))
    {
      if (cmd_list == NULL)
        cmd_list = init_cmd_list (cmd);
      else
        {
          address new_element_addr = LIST_TAPPEND (cmd_list, ccc_cmd_type);
          *(ccc_cmd_type *) new_element_addr = cmd;
        }
    }

  return cmd_list;
}


/* Return an initialized dimension.  */

static dimen_type
dimen_init (real amount)
{
  dimen_type d;
  
  DIMEN_VALID (d) = true;
  DIMEN_ABSOLUTE (d) = false;
  DIMEN_AMOUNT (d) = amount;
  
  return d;
}

/* Return true if the character C is defined; otherwise, give a warning.  */

static boolean
char_known_p (charname_type c)
{
  boolean ok = false;
  
  if (chars[c.code] == NULL)
    CCC_WARN2 ("Character %d (%s) undefined", c.code, c.name);

  else
    ok = true;
  
  return ok;
}
